// ActionScript file
package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.filters.BevelFilter;
	import flash.filters.DropShadowFilter;
	import flash.filters.GlowFilter;
	import flash.geom.Point;
	
	
	public class Piesa extends Sprite
	{
		//cele 8 puncte de control
		public var p1:Point;
		public var p2:Point;
		public var p3:Point;
		public var p4:Point;
		public var p5:Point;
		public var p6:Point;
		public var p7:Point;
		public var p8:Point;
		
		//Pozitia piesei in matricea cu piese
		public var pozX:uint;
		public var pozY:uint;
		
		//puncte ce vor fi calculate si care sunt situate pe 
		//marginea piesei; unirea lor cu linii va forma dorita
		private var puncteComponente:Array = [];
		
		//functie de callback ce va fi apelata pentru mutarea 
		//piesei pe un nivel superior celolrlalte
		private var ridicaPiesa:Function;
		
		//portiune din imagine ce va fi desenata pe piesa
		public var imagineContinuta:Bitmap = new Bitmap(new BitmapData(Global.dimPiesa * 2,Global.dimPiesa * 2,true, 0));
		
		//o masca ce va fi folosita pentru a decupa din imagine
		private var formaPiesa:Sprite = new Sprite();
		
		//o serie de filtre - umbra , contur
		private var filtru1:BevelFilter      = new BevelFilter();
		private var filtru2:DropShadowFilter = new DropShadowFilter();
		private var filtru3:GlowFilter       = new GlowFilter();
		
		//cu valoarea true cand piesa a fost corect pozitionata
		public var corectPozitionata:Boolean = false;
		
		//functie callback pentru testarea finalizarii jocului
		private var verificare:Function;
		
		
		public function Piesa(pozitieX:uint, pozitieY:uint, selecteazaPiesa:Function, verificaStareJoc:Function)
		{
			verificare = verificaStareJoc;
			ridicaPiesa = selecteazaPiesa;
			
			pozY = pozitieX;
			pozX = pozitieY;
			
			//alegem patru puncte in interiorul rombului inscris,
			//obtinut prin unirea mijloacelor laturilor patratului
			p1 = alegePunctInRomb();
			p2 = alegePunctInRomb();
			p3 = alegePunctInRomb();
			p4 = alegePunctInRomb();
			
			//mutam punctele : p1 in stanga , p2 in dreapta, p3 in sus, p4  in jos
			p1.x -= Global.dimPiesa / 2;
			p1.x += Global.dimPiesa / 2;
			p3.y -= Global.dimPiesa / 2;
			p4.y += Global.dimPiesa / 2;
			
			//punctele urmatoare trebuie preluate din piesele
			//vecine deocamdata le asezam pe mijloacelor laturilor:
			
			p5 = new Point(0,uint(Global.dimPiesa / 2));
			p6 = new Point(Global.dimPiesa, uint(Global.dimPiesa / 2));
			p7 = new Point(uint(Global.dimPiesa / 2), 0);
			p8 = new Point(uint(Global.dimPiesa / 2), Global.dimPiesa);
		}
		
		private function alegePunctInRomb():Point
		{
			var punctAles:Point = new Point();
			//incercam sa alegem un punct in interiorul rombului:
			do
			{
				punctAles.x = uint(Math.random() * Global.dimPiesa);
				punctAles.y = uint(Math.random() * Global.dimPiesa);
			}
				
			while(!UtilitarPunct.esteInRomb(punctAles.x,punctAles.y,Global.dimPiesa));
			
			return punctAles;
		}
		
		public function deseneazaPiesa():void
		{
			//avem punctele dar cam si cum ar fi pt prima piesa
			//(stanga-sus) trebuie sa le mutam pentru piesa corecta
			//[cea aflata la [pozX, pozY]
			if (p1.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p1.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p1.y > Global.imagine.height - pozY * Global.dimPiesa)
				p1.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			if (p2.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p2.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p2.y > Global.imagine.height - pozY * Global.dimPiesa)
				p2.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			if (p3.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p3.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p3.y > Global.imagine.height - pozY * Global.dimPiesa)
				p3.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			if (p4.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p4.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p4.y > Global.imagine.height - pozY * Global.dimPiesa)
				p4.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			if (p5.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p5.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p5.y > Global.imagine.height - pozY * Global.dimPiesa)
				p5.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			if (p6.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p6.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p6.y > Global.imagine.height - pozY * Global.dimPiesa)
				p6.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			if (p7.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p7.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p7.y > Global.imagine.height - pozY * Global.dimPiesa)
				p7.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			if (p8.x > Global.imagine.width  - pozX * Global.dimPiesa)
				p8.x = Global.imagine.width  - pozX * Global.dimPiesa;
			if (p8.y > Global.imagine.height - pozY * Global.dimPiesa)
				p8.y = Global.imagine.height - pozY * Global.dimPiesa;
			
			
			// stabilim colturile reale ale pieselor - necesare pentru
			// reprezentarea pieselor marginale care sunt mai mici:
			var colt1:Point = new Point(0,0);
			
			var colt2:Point = new Point(0,Global.dimPiesa > 
				Global.imagine.height - pozY * Global.dimPiesa ?
				Global.imagine.height - pozY * Global.dimPiesa :
				Global.dimPiesa);
			
			var colt3:Point = new Point(Global.dimPiesa >
				Global.imagine.width - pozX * Global.dimPiesa ?
				Global.imagine.width - pozX * Global.dimPiesa :
				Global.dimPiesa , Global.dimPiesa > 
				Global.imagine.height - pozY * Global.dimPiesa ?
				Global.imagine.height - pozY * Global.dimPiesa :
				Global.dimPiesa);
			
			var colt4:Point = new Point(Global.dimPiesa >
				Global.imagine.width - pozX * Global.dimPiesa ?
				Global.imagine.width - pozX * Global.dimPiesa :
				Global.dimPiesa,0);
			
			// se vor adauga punctele curbelor  in tabloul
			//puncteleComponente; fiecare id adauga  cate o curba
			if (p1.y < p5.y) //Curba din Stanga
			{
				this.adaugaPuncteleUneiCurbe(colt1, colt2, p1, p5);
			}
			else
			{
				this.adaugaPuncteleUneiCurbe(colt1, colt2, p5, p1);
			}
			
			if (p4.x < p8.x) //Curba de jos
			{
				this.adaugaPuncteleUneiCurbe(colt2, colt3, p4, p8);
			}
			else
			{
				this.adaugaPuncteleUneiCurbe(colt2, colt3, p8, p4);
			}
			
			if (p2.y > p6.y) //curba din dreapta
			{
				this.adaugaPuncteleUneiCurbe(colt3, colt4, p2, p6);
			}
			else
			{
				this.adaugaPuncteleUneiCurbe(colt3, colt4, p6, p2);
			}
			
			if (p3.x > p7.x) //Curba de sus
			{
				this.adaugaPuncteleUneiCurbe(colt4, colt1, p3, p7);
			}
			else
			{
				this.adaugaPuncteleUneiCurbe(colt4, colt1, p7, p3);
			}
			
			//desenam forma piesei prin trasarea de linii intre
			//punctele memorate in tabloul puncteComponente:
			formaPiesa.graphics.lineStyle(0,0,1);
			formaPiesa.graphics.beginFill(0,1);
			formaPiesa.graphics.moveTo(puncteComponente[0].x,puncteComponente[0].y);
			
			//Forma pieselor va fi desenata intr-o schita a pozitiilor
			//ce va fi utilizata ca ajutor dar jucatorului
			
			Global.multimeCurbe.graphics.lineStyle(0,0,.3);
			Global.multimeCurbe.graphics.moveTo(puncteComponente[0].x + pozX * Global.dimPiesa, puncteComponente[0].y + pozY * Global.dimPiesa);
			
			//trasarea curbelor (din punct in punct)
			for(var i:uint = 0; i<puncteComponente.length; i++)
			{
				formaPiesa.graphics.lineTo(puncteComponente[i].x, puncteComponente[i].y);
				Global.multimeCurbe.graphics.lineTo(puncteComponente[i].x + pozX * Global.dimPiesa,
					puncteComponente[i].y + pozY * Global.dimPiesa);
			}
			
			this.addChild(formaPiesa);
			var piesaCaSprite:Sprite = new Sprite();
			// adaugam imaginea
			piesaCaSprite.addChild(imagineContinuta);
			imagineContinuta.x = -Global.dimPiesa / 2;
			imagineContinuta.y = -Global.dimPiesa / 2;
			this.addChild(piesaCaSprite);
			//o macam pentru a-i da o anumita forma 
			piesaCaSprite.mask = formaPiesa;
			
			filtru1.distance = 1;
			filtru2.angle = 45;
			filtru2.distance = 3;
			filtru2.quality = 3;
			this.filters = [filtru1];
			
			this.addEventListener(MouseEvent.MOUSE_DOWN, mutaPiesa);
			this.addEventListener(MouseEvent.MOUSE_UP, aseazaPiesa);
		}
		
		private function adaugaPuncteleUneiCurbe(p1:Point, p2:Point, c1:Point, c2:Point):void
		{
			var pas:uint = Global.dimPiesa / 3;
			for(var i:uint = 0; i <= pas; i++)
			{
				puncteComponente.push(UtilitarPunct.calculeazaPunctAlCurbeiBezier(p1,p2,c1,c2,i * 100 / pas) );
				
			}
			puncteComponente.push(p2);
		}
		
		private function mutaPiesa(e:MouseEvent):void
		{
			Global.mutari++;
			this.filters = [filtru1 , filtru2];
			this.startDrag();
			ridicaPiesa(this);
		}
		
		private function aseazaPiesa(e:MouseEvent):void
		{
			this.filters = [filtru1];
			
			//se va inceta mutarea piesei
			this.stopDrag();
			
			//daca este aproximativ in pozitie, vom considera ca a fist plasata corect
			if ((Math.abs(this.x - Global.punctDeStart.x - pozX * Global.dimPiesa) < 5 ) && (Math.abs(this.y - Global.punctDeStart.y - pozY * Global.dimPiesa) < 5))
			{
				this.x = pozX * Global.dimPiesa + Global.punctDeStart.x;
				this.y = pozY * Global.dimPiesa + Global.punctDeStart.y;
				
				this.removeEventListener(MouseEvent.MOUSE_UP, aseazaPiesa);
				this.removeEventListener(MouseEvent.MOUSE_DOWN, mutaPiesa);
				
				//o piesa plasata corect nu mai are nevoie de filtre
				this.filters = [];
				Global.corectPlasate++;
				this.corectPozitionata = true;
			}
			
			verificare();
		}
		
		public function aplicaFiltruGLow():void
		{
			if(!corectPozitionata)
			{
				this.filters = [filtru1,filtru3];
			}
			else
			{
				this.filters = [];
			}
		}
		
		public function eliminaFiltruGlow():void
		{
			if(!corectPozitionata)
			{
				this.filters = [filtru1];
			}
			else
			{
				this.filters = [];
			}
		}
		
	}
}